
/*************/
/* bits.c    */
/*************/

typedef unsigned short SET;
#define bit_width 16

 short bit_mask[] = {          1,     
                               2,       
                               4,    
                               8, 
                              16, 
                              32,    
                              64, 
                             128,
			     256, 
                             512, 
                            1024, 
                            2048, 
                            4096, 
                            8192, 
                           16384, 
                           32768};

SET nil_set ()
{
	return 0;
}

SET intersection_set (SET left, SET right)
{
 	return left & right;
}

SET union_set (SET left, SET right)
{
	return left | right;
}

SET difference_set (SET left, SET right)
{
 	return left ^ (left & right);
}

void insert_element (SET *u, short element)
{
	*u  = *u | bit_mask[element];
}

void delete_element (SET *u, short element)
{
	*u  = *u ^ bit_mask[element];
}


int is_element (SET u, short element)
{
	return (u & bit_mask[element]);
}

int is_subset (SET left, SET right)
{
 	return (left == (left & right));
}

int is_empty (SET u)
{
	return (u == 0);
}

int is_disjunct (SET left, SET right)
{
 	return ((left & right) == 0);
}

