/*********************************/
/* files.c                       */
/* Frank Wallner       14.8.96   */
/*********************************/

#include "qq_header.h"

/********************************/
/* Functions                    */
/********************************/

int  fgetline(FILE *filepointer, char *s, int lim)
{
	register char c;
	register int  i=0;

	while ( ((c=getc(filepointer)) != '\n')  && (c != EOF) && (--lim) ) 
		 s[i++] = c;
	if ( c == '\n' ) s[i++] = c;
        if ( (c != EOF) && (lim == 0) ) ungetc(c, filepointer);
	s[i] = '\0';
	return(i);
}
/*-----------------------------------------------------------------*/
int  fputline(FILE *filepointer, char *s, int lim)
{
	register int  i=0;
	register char c;

	while ( ((c=s[i++]) != '\n') && (c != EOF) && (--lim) ) 
		putc(c,filepointer);
	if ( c == '\n' ) putc(c,filepointer);
	return(i);
}
/*-----------------------------------------------------------------*/
FILE *FileOpen(char *filename, char *mode)
{
	FILE *fp;
	if ( ! (fp=fopen(filename,mode)) ) {
	     printf("\n ERROR: Can't open file %s\n\n",filename);
	     exit(1); }
	return(fp);
}
/*-------------------------------------------------------------FIN*/
