/*********************************/
/* graphalgorithms.h             */
/* Frank Wallner       14.2.98   */
/*********************************/

/********************************/
/* Functions                    */
/********************************/

       void  final_search(int v);
       void  non_final_search(int v);
       void  shortest_path(int *costs, int *path, int goal, int s1, int s2);
       void  NBshortest_path(int *costs, int *path, int goal,int s1,int s2);
        int  Is_AcceptingSCC(int start, int stop, int *ffrom, int *tto);

       void  X_final_search(int v);
       void  X_non_final_search(int v);
       void  X_shortest_path(int *costs, int *path, int goal, int s1, int s2);
       void  X_NBshortest_path(int *costs, int *path, int goal,int s1,int s2);
        int  X_Is_AcceptingSCC(int start, int stop, int *ffrom, int *tto);
       void  EN_final_search(ENode *enod);
       void  EN_non_final_search(ENode *enod);

       void  b_search(int v, char mode);
       void  Check_Buechi_Circle(int lastbuechi, ConfS conf, char mode);

       Edge  *Grab_Edge(int v, int e);
       Edge  *S_Grab_Edge(int v, int e, Edge **le);
       Edge  *EN_Grab_Edge(ENCorr *v, int e, Edge **le);
      ENode  *Grab_ENode(int corr, int rep);
      ENode  *ExtGrab_ENode(ENode *enode, int rep);
     ENCorr  *Grab_ENCorr(Int_List *mtl, ENode *en);
       void  *Insert_IL(Int_List **il, int e, Int_List **lastil);
       void  Create_Cand_Lists(Int_List **ncl);	
       void  Init_ENodes(ENode *enod);
       void  UnInit_ENodes(ENode *enod);

/*-----------------------------------------------------------FIN-*/

