/*********************************/
/* outputs.h                     */
/* Frank Wallner       Aug 1998  */
/*********************************/

/* Functions for creating CounterExamples (and for debugging) */
/**************************************************************/
void PrintTS_Simple(FILE *f, BitArray* cutoffconfig, BitArray* corrconfig);  
void PrintConfig(FILE *f, ConfS conf, int transnums);
void PrintConf_TN(FILE *f, ConfS conf);
void fpConfTN(FILE *f, ConfS conf, int *tab);
void PrintTransSeq(FILE *f, int *path, int from, int to);
void X_PrintTransSeq(FILE *f, int *path, int from, int to);
void NB_PrintTransSeq(FILE *f, int *path, int from, int to);
void X_NB_PrintTransSeq(FILE *f, int *path, int from, int to);
void Print_AcceptAll(FILE *f, int event);
char Print_CounterExamples();

void Clean_Up(char *net, char *prop, char *prog_name);
void ShowStatistics();
void Print_LTL_Syntax();
void Print_Usage(char *prog);

/*** only for debugging ***/
void Print_ENCorr_Info(FILE *f, ENode *enod);
void Print_Edges(FILE *f);
 int CountEdges(Edge *ed);
void sPrintConfig(ConfS conf, char* s, int transnums);
void Print_Marking(FILE *f, TE_List *tel, int depth);
void PrintIL(Int_List *il, int tn);
void fPrintIL(FILE *f, Int_List *il, int tn);
void PrintMarking(FILE *f, int corr);
void PrintTPL(trans_PL *t);
void PrintTPL_ALL(FILE *f, trans_PL *t);
/********************************/
/* End of File outputs.h        */
/********************************/

