/***********************************/
/* qq_global.h                     */
/* Frank Wallner  Sep. 98, Apr 99  */
/***********************************/

/**************************************************************************/
/* Global Variables             */
/********************************/

extern        float   all_time_f, unf_time_f, sync_time_f;
extern      etime_t   all_time, unf_time, sync_time;
extern         FILE   *yyin, *yyout, *fres, *fd, *F_OUT;
extern  BuechiTrans   *BTrans;
extern       LMPNet   sysnet;
extern        Event   *ep, *events;
extern         Node   *buechi_nodes;
extern       PNames   *pnames;
extern       TNames   *tnames;
extern     BitArray   bitmask[BA_BASE];
extern     ConfS      conf1, conf2, conf3, conf4;
extern     CutS       cut1, cut2, cut3;
extern      TE_List   **b_post;
extern      TE_List   **enCorrs;
extern        short   observed_places;
extern          int   *place_num, *condition, *corrlist, *cutofflist;
extern          int   *pre_trans;
extern          int   *stack, *b_stack, EN_idx;
extern          int   locEN, globEN, globEN_nc;
extern          int   count, b_count, stackpointer, b_stackpointer;
extern          int   PBuechi, 
		      B_Fin,  
		      real_B_Fin,
		      E_Fin,
		      E_off, 
		      E_corr;
extern          int   maxcorr, 
		      component, 
		      comp_ctr, ffcomp1, ffcomp2, fncomp1, fncomp2,
		      acc_ctr, ffacc1, ffacc2, fnacc1, fnacc2, 
		      aut_acc_ctr,
                      initial_state, 
		      actual_buechi;
extern         char   syncllnet[], 
		      result_SCCs[], 
		      sys_net[], 
		      unfolding[],
                      incomplCtrEx[];
extern         char   **propositions;
extern         char   *current_marking;
extern         char   alreadyNO, 
		      initialize_net, 
		      show_statistics,
		      no_output,
		      incomplete, 
		      final_result, 
		      accepting_component, 
		      all_counterexamples, 
		      extended_output, 
		      print_automaton, 
		      print_aut_as_ll, 
		      good_counterexample;
extern          int   _P_sys, _T_sys,
		      _P_init, _T_init,
		      _P_sync, _T_sync;
extern         SetS   corr_conf, buechi_conf, final_conf, vis_conf;
extern     Int_List   *Accept_all_List;
extern          int   stdout_fd;


/**************************************************************************/
/* End of File qq_global.h      */
/********************************/

