/*******************************************/
/* sf.h                   5.3.98           */
/* Frank Wallner                           */
/*******************************************/


typedef struct obs_ptr {   short nr;
                            char var_name[500];
                          struct obs_ptr* next;
} obs_elm, *OBS;


/****************/
/* VARIABLES    */
/****************/

extern          OBS  observer;
extern unsigned int  file_changed;
extern        short  observed_places;
extern  BuechiTrans  *BTrans;
extern         char  *obs_name(int, OBS*);

/***************************************************************************/

/* Functions used by the scanner */
/*********************************/

extern	  	OBS  find_var_name(char *name, OBS *ol);
extern		OBS  insert_var_name(char *name, OBS *ol);
extern	      char*  obs_name(int lookup_nr, OBS *ol);
extern 	      short  max_used_obs(OBS *ol);
extern 	       void  remove_obs(OBS *ol);

/********************************/
/* End of File sf.h             */
/********************************/

